import { utils, BytesLike, BaseContract, Signer, CallOverrides, BigNumber, PopulatedTransaction } from 'ethers';
import { FunctionFragment, Result } from '@ethersproject/abi';
import { Provider, Listener } from '@ethersproject/providers';
import { TypedEvent, TypedEventFilter, TypedListener, OnEvent } from './common';

interface FeeTypeInterface extends utils.Interface {
    contractName: string | "FeeType";
    functions: {
        "MARKET_SALE()": FunctionFragment;
        "PRIMARY_SALE()": FunctionFragment;
        "ROYALTY()": FunctionFragment;
        "SPLITS()": FunctionFragment;
    };
    encodeFunctionData(functionFragment: "MARKET_SALE", values?: undefined): string;
    encodeFunctionData(functionFragment: "PRIMARY_SALE", values?: undefined): string;
    encodeFunctionData(functionFragment: "ROYALTY", values?: undefined): string;
    encodeFunctionData(functionFragment: "SPLITS", values?: undefined): string;
    decodeFunctionResult(functionFragment: "MARKET_SALE", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "PRIMARY_SALE", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "ROYALTY", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "SPLITS", data: BytesLike): Result;
    events: {};
}
interface FeeType extends BaseContract {
    contractName: string | "FeeType";
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: FeeTypeInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        MARKET_SALE(overrides?: CallOverrides): Promise<[BigNumber]>;
        PRIMARY_SALE(overrides?: CallOverrides): Promise<[BigNumber]>;
        ROYALTY(overrides?: CallOverrides): Promise<[BigNumber]>;
        SPLITS(overrides?: CallOverrides): Promise<[BigNumber]>;
    };
    MARKET_SALE(overrides?: CallOverrides): Promise<BigNumber>;
    PRIMARY_SALE(overrides?: CallOverrides): Promise<BigNumber>;
    ROYALTY(overrides?: CallOverrides): Promise<BigNumber>;
    SPLITS(overrides?: CallOverrides): Promise<BigNumber>;
    callStatic: {
        MARKET_SALE(overrides?: CallOverrides): Promise<BigNumber>;
        PRIMARY_SALE(overrides?: CallOverrides): Promise<BigNumber>;
        ROYALTY(overrides?: CallOverrides): Promise<BigNumber>;
        SPLITS(overrides?: CallOverrides): Promise<BigNumber>;
    };
    filters: {};
    estimateGas: {
        MARKET_SALE(overrides?: CallOverrides): Promise<BigNumber>;
        PRIMARY_SALE(overrides?: CallOverrides): Promise<BigNumber>;
        ROYALTY(overrides?: CallOverrides): Promise<BigNumber>;
        SPLITS(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        MARKET_SALE(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        PRIMARY_SALE(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        ROYALTY(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        SPLITS(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}

export { FeeType, FeeTypeInterface };
